'''
Main module, it provides the starting stuff
'''
import sys,os

# Hack to make the module importable without installing the module
curdir = os.path.dirname(__file__)
sys.path.append(os.path.dirname(curdir))

mod = __import__("filesnake")
sys.modules["filesnake"] = mod

__package__="filesnake"

#from twisted.internet import gtk2reactor # for gtk-2.0
from .networking import gtk2reactor
gtk2reactor.install()
from twisted.internet import reactor
from .networking.interfaces import IUIController

import socket
import settings
from .networking.server import Server

if settings.avahi_available:
    from zeroconf.avahilib import AvahiServicePublisher as ServicePublisher
else:
    try:
        from zeroconf.bonjourlib import BonjourServicePublisher as ServicePublisher
    except WindowsError:
        raise Exception("Could not found bonjour library, provide installing it: search the web bonjour for windows")

from .gui.main_win import FileSnakeGUI

def main():
    fs = FileSnakeGUI()
    
    # Need the spawning of two servers
    serv = Server(IUIController(fs), 0)
    port = serv.port
    
    def publish_service(sn):
        try:
            ServicePublisher(sn,"_filesnake._tcp", port)   
        except:
            publish_service(sn+"_")
            
    publish_service(socket.gethostname())

    fs.show()
    reactor.run()

if __name__ == '__main__':
    main()
