from filesnake.gui.transfers import TransferMonitor, TransferList
from filesnake.helpers.testing import make_file
from filesnake.helpers.path import path_size

import unittest

FNAME, SIZE = make_file("test.txt", 10000)

FOLDER = "."
FOLDER_SIZE = path_size(".")

class TransferListTest(unittest.TestCase):
    def setUp(self):
        self.transfer_list = TransferList()
    
class TestMonitor(unittest.TestCase):
    FNAME = FNAME
    SIZE = SIZE
    def setUp(self):
        self.fmon = TransferMonitor(self.FNAME,self.SIZE)        
    
    def prod_chunks(self, mon, chunksiz, nchunks):
        for i in range(nchunks):
            self.fmon.producing(" "*chunksiz)
    
    def test_exact_transfer(self):
        self.prod_chunks(self.fmon, 10, self.SIZE/10)
        self.assertEquals(self.fmon.progress ,self.SIZE, "Progress different from file size")
        self.assertEquals(self.fmon.complete, 100)
    
    def test_middle_transfer(self):
        self.prod_chunks(self.fmon, 5, self.SIZE/10)
        self.assertEquals(self.fmon.complete, 50)
        
    def test_over_transfer(self):
        # Producing a lot of chunks
        self.assertRaises(ValueError, self.prod_chunks, self.fmon,1000, 100)
        self.assertEquals(self.fmon.progress, self.SIZE, "Progress %i instead of %i"%(self.fmon.progress, self.SIZE))

    def test_finish(self):
        self.prod_chunks(self.fmon, 10, self.SIZE/10)
        self.assertEquals(self.fmon.status, "finish")


