'''
Module for path extra utilities
'''

import os

def get_size(resource):
    if os.path.isdir(resource):
        total_size = 0
        for dirpath, dirnames, filenames in os.walk(resource):
            for f in filenames:
                fp = os.path.join(dirpath, f)
                total_size += os.path.getsize(fp)
        return total_size
    elif os.path.isfile(resource):
        return os.path.getsize(resource)

import re
def avail_filename(fname, starting = 1):
    '''
    get an available filename in case the current yet exists, it adds
    a _1 to the copied file, and if it founds a _1, it substitues a _2
    '''
    if os.path.exists(fname):
        match = re.match("(.*)_(\d+)",fname)
        if match:
            fname, num = match.groups()
            return avail_filename(fname + "_%d" % (int(num) + 1))
        else:
            return avail_filename(fname + "_1")
    else:
        return fname
