'''
Definition of interfaces
'''
from zope.interface import Interface

class IUIController(Interface):
    '''
    This controls the UI uperation.
    
    Ideas:
    It can provide these additional interface or it be splitted in:
    
    IOHandler (for the file handler)
    IMonitorProvider
    IAuthorizator
    '''
    
    def get_file_handler(data):
        '''
        Returns an IFileHandler to handle the file specified
        '''

    def get_monitor(data):
        '''
        Returns a IMonitor to monitor the file/folder specified
        '''

    def authorize(data):
        '''
        '''


class IFileHandler(Interface):
    
    def save_data(data):
        '''
        '''

class IMonitor(Interface):
    '''
    it's a generic monitor that can
    monitor a file transfer.
    '''
    def producing(data):
        '''
        Called when the source is producing data
        '''

    def pause():
        '''
        Called when the source is paused
        '''

    def stop():
        '''
        Called when the source has stopped sending files, ungracefully
        '''

    def finish():
        '''
        The source has finished to do its stuff
        '''

        
