from twisted.internet import protocol
from filesnake.networking.fileprotocol import FileClientProtocol, FileServerProtocol

class PrintMonitor():

    def producing(self):
        '''
        '''
        print "Producing stuff"
    def pause(self):
        '''
        '''
        print "Transfer paused"
    def stop(self):
        '''
        '''
        print "Transfer stopped"
        
    def finish(self):
        '''
        '''
        print "Transfer finished"


class OneFileFactory(protocol.ClientFactory):
    '''
    This factory sends just a file
    '''

    protocol = FileClientProtocol

    def __init__(self, filename):
        self.filename = filename
        
    def get_file(self):
        '''
        '''
        return open(self.filename,"rb")
    def get_monitor(self):
        '''
        '''
        return PrintMonitor()
    

class OneSecretFactory(protocol.ServerFactory):
    
    protocol = FileServerProtocol
    
    def __init__(self, secret):
        self.secret = secret
    
    def check(self, secret):
        return secret == self.secret
    
    def save_data(self, data):
        print "Data received"
    def get_monitor(self):
        return PrintMonitor()

PORT = 10000
TESTFILE = "test.txt"
from twisted.internet import reactor
def server():
    reactor.listenTCP(PORT,OneSecretFactory("hello"))
    reactor.run()
def client():
    factory = OneFileFactory(TESTFILE)
    factory.secret = "hello"
    reactor.connectTCP( "localhost", PORT,factory)
    reactor.run()
    
commands = dict(server=server, client=client)
if __name__ == '__main__':
    import sys
    commands[sys.argv[1]]()
