import dbus
import avahi



def get_avahi_server():
    '''
    It connects to dbus and fetches the avahi server
    '''
    bus = dbus.SystemBus()
    try:
        # Call to get the server
        server = dbus.Interface(
            bus.get_object( avahi.DBUS_NAME, avahi.DBUS_PATH_SERVER ),
            avahi.DBUS_INTERFACE_SERVER )
    except dbus.exceptions.DBusException:
        # avahi not intialized
        raise Exception("Avahi daemon isn't running")

    return server

def get_avahi_entry_group(server):
    # Get the avahi EntryGroup stuff
    bus = dbus.SystemBus()
    group = dbus.Interface(
        bus.get_object(avahi.DBUS_NAME, server.EntryGroupNew()),
        avahi.DBUS_INTERFACE_ENTRY_GROUP)
    return group

#XXX maybe interface protocol, bla bla should be encapsulated in
#service info? maybe no
def get_avahi_service_browser(server, interface, protocol, type, domain):
    bus = dbus.SystemBus()
    b = dbus.Interface(
        bus.get_object(
            avahi.DBUS_NAME, 
            server.ServiceBrowserNew(interface,
                                          protocol,
                                          type,
                                          domain,
                                          dbus.UInt32(0)))
        , avahi.DBUS_INTERFACE_SERVICE_BROWSER)
    return b

